﻿using System.ComponentModel;
using System.Windows;
using System.Windows.Data;
using Infragistics.Windows.DataPresenter.Events;

namespace XamDataGridAddNewCancelSample
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            DemoRows = Rows.GetDemoRows();
            DataContext = this;
        }

        public Rows DemoRows { get; private set; }

        // I think this hack should not be needed at all
        private void RecordUpdateCancelingHandlerToSuppressIssueByHack(object sender, RecordUpdateCancelingEventArgs e)
        {
            var collectionView = CollectionViewSource.GetDefaultView(DemoRows);
            var editableCollectionView = collectionView as IEditableCollectionView;

            if (editableCollectionView.IsAddingNew)
            {
                // uncomment the following command to suppress the issue
                // I think of this as a bad hack with possible side effects.
                // -----
                //editableCollectionView.CommitNew();

                // this should work either, but the used implementation (System.Windows.Data.BindingListCollectionView) 
                // look at the lasts block comment of the microsoft coode below. It seems the issue comes
                // fom _newItem is not reset to NoNewItem in CancelNew(), but it is in CommitNew().
                editableCollectionView.CancelNew();
            }
        }

        // Here comes the original sourcecode of the CancelNew() method found at
        // http://referencesource.microsoft.com/#PresentationFramework/src/Framework/System/Windows/Data/BindingListCollectionView.cs
        // -----

        ///// <summary>
        ///// Complete the transaction started by <seealso cref="AddNew"/>.  The new
        ///// item is removed from the collection.
        ///// </summary>
        //public void CancelNew()
        //{
        //    if (IsEditingItem)
        //        throw new InvalidOperationException(SR.Get(SRID.MemberNotAllowedDuringTransaction, "CancelNew", "EditItem"));
        //    VerifyRefreshNotDeferred();
 
        //    if (_newItem == NoNewItem)
        //        return;
 
        //    // cancel the AddNew
        //    ICancelAddNew ican = InternalList as ICancelAddNew;
        //    IEditableObject ieo;
 
        //    BindingOperations.AccessCollection(InternalList,
        //        () =>
        //        {
        //            ProcessPendingChanges();
 
        //            if (ican != null)
        //            {
        //                ican.CancelNew(_newItemIndex);
        //            }
        //            else if ((ieo = _newItem as IEditableObject) != null)
        //            {
        //                ieo.CancelEdit();
        //            }
        //        },
        //        true);
 
        //    // DataView raises events that cause us to update the view
        //    // correctly (including leaving AddNew mode).  BindingList<T> does not
        //    // raise these events.  If they haven't happened, do the work now.
        //    if (_newItem != NoNewItem)
        //    {
        //        Debug.Assert(true);
        //    }
        //}
    }
}
